#include <iostream>
#include "wavdata.h"
#include "fft.h"
#include <math.h>

#define FREQ 48000
#define AMPLITUDE 10
#define FREQDO 261
#define FREQLA	440
#define SIZE FREQ*10


int main(int argc, char **argv)
{
	float pi=3.141592;
	WavData w;
	
	char *data = new char[SIZE];
	char *data2 = new char[SIZE];

    int i;
	for(i=0;i<SIZE;i++){
		float w=2.0*3.14*FREQLA;
		float t=(float)i/FREQ;

		data[i]=AMPLITUDE*(1+sin(w*t));
    }

	
	w.setAudioFormat(1);
	w.setNbrChanel(1);
	w.setFrequency(FREQ);
	w.setBytePerBloc(4);
	w.setBytePerSec(FREQ);
	w.setBitsPerSample(8);
	w.clearData();
	
	w.setDatasize(SIZE);
	w.setData(data);
	w.save("purla.WAV");

}